#<profile4xi profile = "31"/>
#<program4xi program = "test_gun4search.py">
#<abstract4xi abstract = "tests gun functions"/>
#<refer4xi reference = "automate2analyse4xi.py"/>
#<note4xi note = "none"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
# to test target functions given to processes by automate2analyse4xi.py
#
# TIPS:
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_gun4search.py' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string

import threading                
import _thread
import _winapi

import signal
import itertools
import weakref
import logging 

#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
from version4xi import ROOT4XI
#dynamic-start
from generate2gun4search import generate2gun4search
from generate2shoot4search import generate2shoot4search
#dynamic-end
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

# -------------------------------
# dragon, zero, one ... eight
# -------------------------------
from gun2dragon4search import gun2dragon4search
from gun2zero4search import gun2zero4search
from gun2one4search import gun2one4search
from gun2two4search import gun2two4search
from gun2three4search import gun2three4search
from gun2four4search import gun2four4search
from gun2five4search import gun2five4search
from gun2six4search import gun2six4search
from gun2seven4search import gun2seven4search
from gun2eight4search import gun2eight4search
from gun2nine4search import gun2nine4search
from gun2ten4search import gun2ten4search
from gun2eleven4search import gun2eleven4search
from gun2twelve4search import gun2twelve4search
#dynamic-start
from gun2thirteen4search import gun2thirteen4search
#dynamic-end
from current_process4xi import get_current_process4xi            
from current_process4xi import get_identity_current_process4xi
from current_process4xi import get_name_current_process4xi

from dummyprocess4xi import DummyProcess4Xi

from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import Print4Xi 


from print4xi import print4xi
from print4xi import set_print_permission4xi
from process4xi import Process4Xi

from queue4xi import Queue4Xi

from sleep4xi import omega2sleep4xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2message4index

global ack4queues
global nack4queues

global ack4pipes
global nack4pipes

global ack4process
global nack4process

global ack4start
global nack4start   
        
global ack4run
global nack4run

global AlphaKB4Xi
global keys2AlphaKB4Xi
global key2AlphaKB4Xi

global IndexKB4Xi
global keys2IndexKB4Xi
global key2IndexKB4Xi

global LevelOneKB4Xi
global keys2LevelOneKB4Xi
global key2LevelOneKB4Xi

global LevelTwoKB4Xi
global keys2LevelTwoKB4Xi
global key2LevelTwoKB4Xi

global CountTwoKB4Xi
global keys2CountTwoKB4Xi
global key2CountTwoKB4Xi

global DomainKB4Xi
global keys2DomainKB4Xi
global key2DomainKB4Xi

global LevelThreeKB4Xi
global keys2LevelThreeKB4Xi
global key2LevelThreeKB4Xi

global LevelFourKB4Xi
global keys2LevelFourKB4Xi
global key2LevelFourKB4Xi

global LevelFiveKB4Xi
global keys2LevelFiveKB4Xi
global key2LevelFiveKB4Xi

global LevelSixKB4Xi
global keys2LevelSixKB4Xi
global key2LevelSixKB4Xi

global LevelSevenKB4Xi
global keys2LevelSevenKB4Xi
global key2LevelSevenKB4Xi

global LevelEightKB4Xi
global keys2LevelEightKB4Xi
global key2LevelEightKB4Xi

global master2analyse4search 
global dragon2analyse4search 
global zero2analyse4search                          
global one2analyse4search
global two2analyse4search
global three2analyse4search
global four2analyse4search
global five2analyse4search
global six2analyse4search
global seven2analyse4search
global eight2analyse4search
global nine2analyse4search
global ten2analyse4search
global eleven2analyse4search
global twelve2analyse4search
#dynamic-start
global thirteen2analyse4search
#dynamic-end

global path2temp4xi                          # path for output files
global PickleKB4Xi

global NameKB4Xi
global keys2NameKB4Xi
global key2NameKB4Xi

global MonthKB4Xi
global keys2MonthKB4Xi
global key2MonthKB4Xi

global t2xi 
global trace_object_count 
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings 
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2message4index = False
AlphaKB4Xi      = {}
AlphaKB4Xi['a'] = {}
AlphaKB4Xi['b'] = {}
AlphaKB4Xi['c'] = {}
AlphaKB4Xi['d'] = {}
AlphaKB4Xi['e'] = {}
AlphaKB4Xi['f'] = {}
AlphaKB4Xi['g'] = {}
AlphaKB4Xi['h'] = {}
AlphaKB4Xi['i'] = {}
AlphaKB4Xi['j'] = {}
AlphaKB4Xi['k'] = {}
AlphaKB4Xi['l'] = {}
AlphaKB4Xi['m'] = {}
AlphaKB4Xi['n'] = {}
AlphaKB4Xi['o'] = {}
AlphaKB4Xi['p'] = {}
AlphaKB4Xi['q'] = {}
AlphaKB4Xi['r'] = {}
AlphaKB4Xi['s'] = {}
AlphaKB4Xi['t'] = {}
AlphaKB4Xi['u'] = {}
AlphaKB4Xi['v'] = {}
AlphaKB4Xi['w'] = {}
AlphaKB4Xi['x'] = {}
AlphaKB4Xi['y'] = {}
AlphaKB4Xi['z'] = {} 
keys2AlphaKB4Xi = AlphaKB4Xi.keys()
key2AlphaKB4Xi  = 0

IndexKB4Xi = {}
IndexKB4Xi[0] = {}
IndexKB4Xi[1] = {}
IndexKB4Xi[2] = {}
IndexKB4Xi[3] = {}
IndexKB4Xi[4] = {}
IndexKB4Xi[5] = {}
IndexKB4Xi[6] = {}
IndexKB4Xi[7] = {}
IndexKB4Xi[8] = {}
keys2IndexKB4Xi = IndexKB4Xi.keys()
key2IndexKB4Xi  = 0        

LevelOneKB4Xi = {}
keys2LevelOneKB4Xi = LevelOneKB4Xi.keys()
key2LevelOneKB4Xi  = 0

LevelTwoKB4Xi = {}
keys2LevelTwoKB4Xi = LevelTwoKB4Xi.keys()
key2LevelTwoKB4Xi  = 0

CountTwoKB4Xi = {}
keys2CountTwoKB4Xi = CountTwoKB4Xi.keys()
key2CountTwoKB4Xi  = 0

DomainKB4Xi = {}
keys2DomainKB4Xi = DomainKB4Xi.keys()
key2DomainKB4Xi  = 0

LevelThreeKB4Xi = {}
keys2LevelThreeKB4Xi = LevelThreeKB4Xi.keys()
key2LevelThreeKB4Xi  = 0

LevelFourKB4Xi = {}
keys2LevelFourKB4Xi = LevelFourKB4Xi.keys()
key2LevelFourKB4Xi  = 0

LevelFiveKB4Xi = {}
keys2LevelFiveKB4Xi = LevelFiveKB4Xi.keys()
key2LevelFiveKB4Xi  = 0

LevelSixKB4Xi = {}
keys2LevelSixKB4Xi = LevelSixKB4Xi.keys()
key2LevelSixKB4Xi  = 0

LevelSevenKB4Xi = {}
keys2LevelSevenKB4Xi = LevelSevenKB4Xi.keys()
key2LevelSevenKB4Xi  = 0

LevelEightKB4Xi = {}
keys2LevelEightKB4Xi = LevelEightKB4Xi.keys()
key2LevelEightKB4Xi  = 0    

NameKB4Xi = {}
keys2NameKB4Xi = NameKB4Xi.keys()
key2NameKB4Xi  = 0

MonthKB4Xi = {}
MonthKB4Xi['january'] = {}
MonthKB4Xi['february'] = {} 
MonthKB4Xi['march'] = {} 
MonthKB4Xi['april'] = {} 
MonthKB4Xi['may'] = {} 
MonthKB4Xi['june'] = {} 
MonthKB4Xi['july'] = {} 
MonthKB4Xi['august'] = {} 
MonthKB4Xi['september'] = {}
MonthKB4Xi['october'] = {}
MonthKB4Xi['november'] = {}
MonthKB4Xi['december'] = {}
keys2MonthKB4Xi = MonthKB4Xi.keys()

# ------------------------------
# paths to input
# ------------------------------
master2analyse4search  = VersionKB4Xi['master2analyse4search']
dragon2analyse4search  = VersionKB4Xi['dragon2analyse4search']
zero2analyse4search  = VersionKB4Xi['zero2analyse4search']
one2analyse4search  = VersionKB4Xi['one2analyse4search']
two2analyse4search  = VersionKB4Xi['two2analyse4search']
three2analyse4search  = VersionKB4Xi['three2analyse4search']
four2analyse4search  = VersionKB4Xi['four2analyse4search']
five2analyse4search  = VersionKB4Xi['five2analyse4search']
six2analyse4search  = VersionKB4Xi['six2analyse4search']
seven2analyse4search  = VersionKB4Xi['seven2analyse4search']
eight2analyse4search  = VersionKB4Xi['eight2analyse4search'] 
nine2analyse4search  = VersionKB4Xi['nine2analyse4search'] 
ten2analyse4search  = VersionKB4Xi['ten2analyse4search'] 
eleven2analyse4search  = VersionKB4Xi['eleven2analyse4search']    
twelve2analyse4search  = VersionKB4Xi['twelve2analyse4search']             
#dynamic-start
thirteen2analyse4search  = VersionKB4Xi['thirteen2analyse4search']
#dynamic-end         

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 00A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 00B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 002A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
    # 10:55:18 01/09/15 FLE Standard Time 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 001A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  19:04:49 01/21/15 FLE Standard Time
    print("(Step 001B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x02A9A250>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001C/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 001D/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 001E/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEROOT4XI PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 001F/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 001Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001G/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 002F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
    # COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  19:04:49 01/21/15 FLE Standard Time
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x02A9A250>
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Pipe4Xi': 'NACK4TRACE',
         'Queue4Xi': 'NACK4TRACE',         
         'Process4Xi': 'NACK4TRACE',
         'test_gun4search': 'NACK4TRACE',
         'gun2dragon4search': 'NACK4TRACE',
         'gun2zero4search': 'NACK4TRACE',
         'gun2one4search': 'NACK4TRACE',
         'gun2two4search': 'NACK4TRACE',
         'gun2three4search': 'NACK4TRACE',
         'gun2four4search': 'NACK4TRACE',
         'gun2five4search': 'NACK4TRACE',
         'gun2six4search': 'NACK4TRACE',
         'gun2seven4search': 'NACK4TRACE',
         'gun2eight4search': 'NACK4TRACE',
         'gun2nine4search': 'NACK4TRACE',
         'gun2ten4search': 'NACK4TRACE',
         'gun2eleven4search': 'NACK4TRACE',
         'gun2twelve4search': 'NACK4TRACE',
         #dynamic-start
         'gun2thirteen4search': 'NACK4TRACE',
         #dynamic-end
         'shoot2dragon4search': 'NACK4TRACE',
         'shoot2zero4search': 'NACK4TRACE',
         'shoot2one4search': 'NACK4TRACE',
         'shoot2two4search': 'NACK4TRACE',
         'shoot2three4search': 'NACK4TRACE',
         'shoot2four4search': 'NACK4TRACE',
         'shoot2five4search': 'NACK4TRACE',
         'shoot2six4search': 'NACK4TRACE',
         'shoot2seven4search': 'NACK4TRACE',
         'shoot2eight4search': 'NACK4TRACE',
         'shoot2nine4search': 'NACK4TRACE',
         'shoot2ten4search': 'NACK4TRACE',
         'shoot2eleven4search': 'NACK4TRACE',
         'shoot2twelve4search': 'NACK4TRACE',
         #dynamic-start
         'shoot2thirteen4search': 'NACK4TRACE'
         #dynamic-end
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi
        # Process4Xi
        # Queue4Xi
        # test_gun4search
        # gun2dragon4search
        # gun2eight4search
        # gun2five4search
        # gun2four4search
        # gun2one4search
        # gun2seven4search
        # gun2six4search
        # gun2three4search
        # gun2two4search
        # gun2zero4search
        # shoot2dragon4search
        # shoot2eight4search
        # shoot2five4search
        # shoot2four4search
        # shoot2one4search
        # shoot2seven4search
        # shoot2six4search
        # shoot2three4search
        # shoot2two4search
        # shoot2zero4search

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # COMPLETED  TAILORING:  19:04:49 01/21/15 FLE Standard Time

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "test_gun4search.py"
    method2print = "test_gun4search.py" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-test_gun4search.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing test_gun4search.py.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">test_gun4search.py sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-test_gun4search.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for test_gun4search.py.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-test_gun4search.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for test_gun4search.py.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of test_gun4search.py.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2message4index

    global ack4queues
    global nack4queues

    global ack4pipes
    global nack4pipes

    global ack4process
    global nack4process

    global ack4start
    global nack4start   
        
    global ack4run
    global nack4run
    
    global AlphaKB4Xi
    global keys2AlphaKB4Xi
    global key2AlphaKB4Xi

    global IndexKB4Xi
    global keys2IndexKB4Xi
    global key2IndexKB4Xi
    
    global LevelOneKB4Xi
    global keys2LevelOneKB4Xi
    global key2LevelOneKB4Xi
    
    global LevelTwoKB4Xi
    global keys2LevelTwoKB4Xi
    global key2LevelTwoKB4Xi

    global CountTwoKB4Xi
    global keys2CountTwoKB4Xi
    global key2CountTwoKB4Xi    

    global DomainKB4Xi
    global keys2DomainKB4Xi
    global key2DomainKB4Xi
            
    global LevelThreeKB4Xi
    global keys2LevelThreeKB4Xi
    global key2LevelThreeKB4Xi
    
    global LevelFourKB4Xi
    global keys2LevelFourKB4Xi
    global key2LevelFourKB4Xi
    
    global LevelFiveKB4Xi
    global keys2LevelFiveKB4Xi
    global key2LevelFiveKB4Xi
    
    global LevelSixKB4Xi
    global keys2LevelSixKB4Xi
    global key2LevelSixKB4Xi
    
    global LevelSevenKB4Xi
    global keys2LevelSevenKB4Xi
    global key2LevelSevenKB4Xi
    
    global LevelEightKB4Xi
    global keys2LevelEightKB4Xi
    global key2LevelEightKB4Xi    
            
    global NameKB4Xi
    global keys2NameKB4Xi
    global key2NameKB4Xi
 
    global MonthKB4Xi
    global keys2MonthKB4Xi
    global key2MonthKB4Xi  
        
    global master2analyse4search
    global dragon2analyse4search   
    global zero2analyse4search
    global one2analyse4search
    global two2analyse4search 
    global three2analyse4search 
    global four2analyse4search
    global five2analyse4search
    global six2analyse4search 
    global seven2analyse4search 
    global eight2analyse4search 
    global nine2analyse4search
    global ten2analyse4search
    global eleven2analyse4search
    global twelve2analyse4search
    #dynamic-start
    global thirteen2analyse4search
    #dynamic-end
    
    global path2temp4xi

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF TEST_GUN4SEARCH - SET T2XI TO: ", t2xi)  
    # <print4xi.Print4Xi object at 0x02A9A250> 

    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
       
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    
    #dynamic-start
    print ('(STEP 1Q/33) OF TEST_GUN4SEARCH - THIRTEEN2ANALYSE4XI: ', thirteen2analyse4search)
    # M://temp//yophotos//test2thirteen//  
    #dynamic-end
    
    # =============================================================================================   
    # (Step 3/33)
    # =============================================================================================       
    print("(STEP 3A/33) OF TEST_GUN4SEARCH - CREATING PIPES WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
    # CREATING PIPES WITH CONSUMER AND PUBLISHER ENDS  10:56:34 02/04/15 FLE Standard Time

    
    #dynamic-start
                               
    try:
        # -----------------------------------------------------------------------------------------    
        # THIRTEEN PIPE
        # -----------------------------------------------------------------------------------------     
              
        pipe2thirteen_consumer_channel, pipe2thirteen_publisher_channel = Pipe4Xi()
        
        print("(STEP 3D13A/33) OF TEST_GUN4SEARCH - CREATED PIPE2THIRTEEN_CONSUMER_CHANNEL")   
        print(pipe2thirteen_consumer_channel)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x02D5BA50>
        
        print("(STEP 3D13B/33) OF TEST_GUN4SEARCH - CREATED PIPE2THIRTEEN_PUBLISHER_CHANNEL")  
        print(pipe2thirteen_publisher_channel)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x02D5BA30>
       
    except:
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        print("(STEP 3ZD13/33) OF TEST_GUN4SEARCH *** FAILED TO CREATE PIPE2THIRTEEN ***")            
    #dynamic-end
            

    #dynamic-start
    try:
        # -----------------------------------------------------------------------------------------    
        # THIRTEEN QUEUE
        # -----------------------------------------------------------------------------------------     
        
        print('=' *33)    
        print("(STEP 3V13A/33) OF TEST_GUN4SEARCH - CREATING QUEUE2THIRTEEN")
        print('=' *33)           
             
        queue2thirteen = Queue4Xi()
        
        print('=' *33)    
        print("(STEP 3V13B/33) OF TEST_GUN4SEARCH - CREATED QUEUE2THIRTEEN: ", queue2thirteen)
        # CREATED QUEUE2THIRTEEN:  <queue4xi.Queue4Xi object at 0x02D5BC90>
        
    except:
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        print("(STEP 3Z13/33) OF TEST_GUN4SEARCH *** FAILED TO CREATE QUEUE2THIRTEEN ***")        
    #dynamic-end
    
    # =============================================================================================   
    # (Step 4/33) - COMMAND AND CONTROL
    # =============================================================================================         

    
    #dynamic-start
    try:
        # -------------------------------------------------------------------------------------------------
        # PUT COMMAND AND CONTROL MESSAGES TO THIRTEEN                        
        # ------------------------------------------------------------------------------------------------- 
        message2put4thirteen = "<copy4xi>copy2thirteen</copy4xi>"
        queue2thirteen.put(message2put4thirteen)
        print("(STEP 4J13/33) OF TEST_GUN4SEARCH - PUT TO QUEUE2THIRTEEN: ", queue2thirteen, " MESSAGE2PUT4THIRTEEN: " , message2put4thirteen)
        # PUT TO QUEUE2THIRTEEN:  <queue4xi.Queue4Xi object at 0x02D5BC90>  MESSAGE2PUT4THIRTEEN:  <copy4xi>copy2thirteen</copy4xi>
    except:
        print("(STEP 4Z13/33) OF TEST_GUN4SEARCH *** FAILED TO PUT COMMAND AND CONTROL MESSAGES ", time4xi())        
    #dynamic-end             
    

    
    #dynamic-start
   
    try:    
        # -------------------------------------------------------------------------------------------------
        # SEND COMMAND AND CONTROL MESSAGES TO THIRTEEN                          
        # -------------------------------------------------------------------------------------------------                 
        message2send4thirteen = "<copy4xi>copy2thirteen</copy4xi>"
        pipe2thirteen_publisher_channel.send(message2send4thirteen)
        print("(STEP 4U13/33) OF TEST_GUN4SEARCH - SENT TO PIPE2THIRTEEN_PUBLISHER_CHANNEL: ", pipe2thirteen_publisher_channel, " MESSAGE2SEND4THIRTEEN: " , message2send4thirteen)
        # SENT TO PIPE2THIRTEEN_PUBLISHER_CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x02D5BA30>  MESSAGE2SEND4THIRTEEN:  <copy4xi>copy2thirteen</copy4xi> 
    except:
        print("(STEP 4Z13/33) OF TEST_GUN4SEARCH *** FAILED TO SEND COMMAND AND CONTROL MESSAGES TO PIPES  ", time4xi())
                
    #dynamic-end
    

    
    #dynamic-start         
    dynamic2direction = "thirteen"
    autonomous2dynamic = True
    if autonomous2dynamic is True:
        print("(STEP 200A/33) OF TEST_GUN4SEARCH - TRYING TO GENERATE GUN CODE FOR DIRECTION: ", dynamic2direction)  
        # thirteen 
        
        try:
            path2read4xi  = VersionKB4Xi['folder2read4dragon']  # defines folder to be read
            print ('(STEP 200B/33) OF TEST_GUN4SEARCH - PATH2READ4XI: ', path2read4xi)
            # E://temp//dragonize//in//
            path2write4xi = VersionKB4Xi['folder2write4dragon'] # defines folder to save programs
            print ('(STEP 200C/33) OF TEST_GUN4SEARCH - PATH2WRITE4XI: ', path2write4xi)
            # E://temp//dragonize//out//
            for file2walk in DirectoryWalker(path2read4xi):
                if os.path.isdir(file2walk):
                    print ("(STEP 200D/33) OF TEST_GUN4SEARCH - DIRECTORY: " + file2walk + '\n')
                    #  
                if os.path.isfile(file2walk):
                    print ("(STEP 200E/33) OF TEST_GUN4SEARCH - INPUT FILE: " + file2walk + '\n')
                    # E://temp//dragonize//in//gun2dragon4search.py
                    # E://temp//dragonize//in//shoot2dragon4search.py
                    
                    string2look = "gun2dragon4search"
                    index2look = str.find(file2walk,string2look) 
                    if index2look == -1:
                        print ("(STEP 200F/33) OF TEST_GUN4SEARCH - SKIPPED INPUT FILE: " + file2walk + '\n')
                        # E://temp//dragonize//in//shoot2dragon4search.py 
                    else:
                        print ("(STEP 200G/33) OF TEST_GUN4SEARCH - ACCEPTED INPUT GUN FILE: " + file2walk + '\n')
                        # E://temp//dragonize//in//gun2dragon4search.py
                            
                        generate2gun4search(file2walk, direction2process = dynamic2direction)
                        print ("(STEP 200H/33) OF TEST_GUN4SEARCH - PERFORMED GENERATE2GUN4SEARCH: ", generate2gun4search)
                        # <function generate2gun4search at 0x029E58A0>
                        
                                            
                        # -------------------------------------------------------------------------------------------------
                        # UPDATE SYSTEM PATH - GENERATED MODULES ARE NOT COPIED TO SOURCE FOLDER BECAUSE THEY ARE TEMPORARY
                        # -------------------------------------------------------------------------------------------------    
                        print ("(STEP 200I/33) OF TEST_GUN4SEARCH - TRYING TO MAKE SURE GENERATED SHOOT MODULE CAN BE IMPORTED FROM PATH2WRITE4XI ", path2write4xi)
                        # E://temp//dragonize//out//
                        try:
                            sys.path.index(path2write4xi)
                            print ("(STEP 200J/33) OF TEST_GUN4SEARCH - KEPT SYSTEM PATH, FOUND EXISTING: ", path2write4xi)
                            # 
                        except:
                            sys.path.append(path2write4xi)
                            print ("(STEP 200K/33) OF TEST_GUN4SEARCH - UPDATED SYSTEM PATH WITH PATH2WRITE4XI: ", sys.path) 
                            # ['E:\\STUDIO4XI\\Python\\3.3\\src', 'd:\\Python33', 'C:\\Windows\\SYSTEM32\\python33.zip', 
                            #  'd:\\Python33\\DLLs', 'd:\\Python33\\lib', 'd:\\Python33\\lib\\site-packages',
                            #  '..//..//..//..//sw4xi//python33//lib//multiprocessing//', '..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//',
                            #  '..//..//..//..//studio4xi//python//3.3//src//', '..//..//..//..//sw4xi//python33//zap//', 
                            #  '..//..//..//..//scope4xi//041721//zap//lib//a//', 
                            #  ...
                            #  '..//..//..//..//scope4xi//041721//zap//lib//_//',
                            # 'E://temp//dragonize//out//']      
        except:
            print("(STEP 200Z1/33) OF TEST_GUN4SEARCH *** FAILED TO DYNAMICALLY GENERATE GUN CODE ", time4xi())  
            #             
            
        print("(STEP 210A/33) OF TEST_GUN4SEARCH - TRYING TO GENERATE SHOOT CODE FOR DIRECTION: ", dynamic2direction)  
        # thirteen
    
        try:
            path2read4xi  = VersionKB4Xi['folder2read4dragon']  # defines folder to be read
            print ('(STEP 210B/33) OF TEST_GUN4SEARCH - PATH2READ4XI: ', path2read4xi)
            # E://temp//dragonize//in// 
            path2write4xi = VersionKB4Xi['folder2write4dragon'] # defines folder to save programs
            print ('(STEP 210C/33) OF TEST_GUN4SEARCH - PATH2WRITE4XI: ', path2write4xi)
            # E://temp//dragonize//out//
            for file2walk in DirectoryWalker(path2read4xi):
                if os.path.isdir(file2walk):
                    print ("(STEP 210D/33) OF TEST_GUN4SEARCH - DIRECTORY: " + file2walk + '\n')
                    #  
                if os.path.isfile(file2walk):
                    print ("(STEP 210E/33) OF TEST_GUN4SEARCH - INPUT FILE: " + file2walk + '\n')
                    # E://temp//dragonize//in//gun2dragon4search.py
                    # E://temp//dragonize//in//shoot2dragon4search.py
                    
                    string2look = "shoot2dragon4search"
                    index2look = str.find(file2walk,string2look) 
                    if index2look == -1:
                        print ("(STEP 210F/33) OF TEST_GUN4SEARCH - SKIPPED INPUT FILE: " + file2walk + '\n')
                        # E://temp//dragonize//in//gun2dragon4search.py
                    else:
                        print ("(STEP 210G/33) OF TEST_GUN4SEARCH - ACCEPTED INPUT FILE: " + file2walk + '\n')
                        # E://temp//dragonize//in//shoot2dragon4search.py
                            
                        generate2shoot4search(file2walk, direction2process = dynamic2direction)
                        print ("(STEP 210H/33) OF TEST_GUN4SEARCH - PERFORMED GENERATE2GUN4SEARCH: ", generate2gun4search)
                        # <function generate2gun4search at 0x02A678A0>
                        
                        # -------------------------------------------------------------------------------------------------
                        # UPDATE SYSTEM PATH - GENERATED MODULES ARE NOT COPIED TO SOURCE FOLDER BECAUSE THEY ARE TEMPORARY
                        # -------------------------------------------------------------------------------------------------    
                        print ("(STEP 210I/33) OF TEST_GUN4SEARCH - TRYING TO MAKE SURE GENERATED MODULES CAN BE IMPORTED FROM PATH2WRITE4XI ", path2write4xi)
                        # E://temp//dragonize//out//
                        try:
                            sys.path.index(path2write4xi)
                            print ("(STEP 210J/33) OF TEST_GUN4SEARCH - KEPT SYSTEM PATH, FOUND EXISTING: ", path2write4xi)
                            # KEPT SYSTEM PATH, FOUND EXISTING:  E://temp//dragonize//out//
                        except:
                            sys.path.append(path2write4xi)
                            print ("(STEP 210K/33) OF TEST_GUN4SEARCH - UPDATED SYSTEM PATH FOR PATH2WRITE4XI: ", sys.path) 
                            # 
                        
        except:
            print("(STEP 210Z1/33) OF TEST_GUN4SEARCH *** FAILED TO DYNAMICALLY GENERATE SHOOT CODE ", time4xi())  
            # 
    
    
        print("(STEP 220A/33) OF TEST_GUN4SEARCH - TRYING TO IMPORT GENERATED FUNCTIONS ", time4xi())  
        # Note: import creates _pycache_ folder in the directory where functions are imported i.e. the command compiles!       
        if dynamic2direction == "thirteen":
            try: 
                from gun2thirteen4search import gun2thirteen4search
                print("(STEP 220B/33) OF TEST_GUN4SEARCH - IMPORTED GENERATED GUN2THIRTEEN4SEARCH ", gun2thirteen4search)  
                # <module 'gun2thirteen4search' from 'E://temp//dragonize//out//gun2thirteen4search.py'> 
            except:
                print("(STEP 220Z1/33) OF TEST_GUN4SEARCH *** FAILED TO IMPORT GUN2THIRTEEN4SEARCH ", time4xi())  
                #     
            try: 
                from shoot2thirteen4search import shoot2thirteen4search
                print("(STEP 220C/33) OF TEST_GUN4SEARCH - IMPORTED GENERATED SHOOT2THIRTEEN4SEARCH ", shoot2thirteen4search)  
                # <module 'shoot2thirteen4search' from 'E://temp//dragonize//out//shoot2thirteen4search.py'>  
            except:
                print("(STEP 220Z2/33) OF TEST_GUN4SEARCH *** FAILED TO IMPORT SHOOT2THIRTEEN4SEARCH ", time4xi())  
                #       
        else:
            print("(STEP 220D/33) OF TEST_GUN4SEARCH - SKIPPED IMPORTING WITH DYNAMIC2DIRECTION ", dynamic2direction)          
    else:
        # ------------------------------------------------------------------------------ 
        # STATIC IMPORT
        # ------------------------------------------------------------------------------     
        print("(STEP 220E/33) OF TEST_GUN4SEARCH - IMPORTING NORMALLY FOR DIRECTION ", dynamic2direction)      
        try: 
            import gun2thirteen4search
            print("(STEP 220F/33) OF TEST_GUN4SEARCH - IMPORTED GENERATED GUN2THIRTEEN4SEARCH ", gun2thirteen4search)  
            # <module 'gun2thirteen4search' from 'E:\\STUDIO4XI\\Python\\3.3\\src\\gun2thirteen4search.py'>
        except:
            print("(STEP 220Z3/33) OF TEST_GUN4SEARCH *** FAILED TO IMPORT GUN2THIRTEEN4SEARCH ", time4xi())  
            #     
        try: 
            import shoot2thirteen4search
            print("(STEP 220C/33) OF TEST_GUN4SEARCH - IMPORTED GENERATED SHOOT2THIRTEEN4SEARCH ", shoot2thirteen4search)  
            # <module 'shoot2thirteen4search' from 'E:\\STUDIO4XI\\Python\\3.3\\src\\shoot2thirteen4search.py'>
        except:
            print("(STEP 220Z4/33) OF TEST_GUN4SEARCH *** FAILED TO IMPORT SHOOT2THIRTEEN4SEARCH ", time4xi())  
            #        
 
        print("(STEP 320E/33) OF TEST_GUN4SEARCH - IMPORTING NORMALLY FOR TWELVE ", dynamic2direction)      
        try: 
            import gun2twelve4search
            print("(STEP 320F/33) OF TEST_GUN4SEARCH - IMPORTED GENERATED GUN2TWELVE4SEARCH ", gun2twelve4search)  
            # 
        except:
            print("(STEP 320Z3/33) OF TEST_GUN4SEARCH *** FAILED TO IMPORT GUN2TWELVE4SEARCH ", time4xi())  
            #     
        try: 
            import shoot2twelve4search
            print("(STEP 320C/33) OF TEST_GUN4SEARCH - IMPORTED GENERATED SHOOT2TWELVE4SEARCH ", shoot2twelve4search)  
            # 
        except:
            print("(STEP 320Z4/33) OF TEST_GUN4SEARCH *** FAILED TO IMPORT SHOOT2TWELVE4SEARCH ", time4xi())  
            #                       
                   
           
    if dynamic2direction == "thirteen":        
    
        try:
            # ------------------------------------------------------------------------------ 
            # THIRTEEN-GUN WITH MULTIPROCESSING4XI
            # ------------------------------------------------------------------------------     
    
            print ("(STEP 113A1/33) OF TEST_GUN4SEARCH - PASSING QUEUE2THIRTEEN ", queue2thirteen)
            # QUEUE2THIRTEEN  <queue4xi.Queue4Xi object at 0x02C3A770>
            print ("(STEP 113A2/33) OF TEST_GUN4SEARCH - PASSING PIPE2THIRTEEN_CONSUMER_CHANNEl ", pipe2thirteen_consumer_channel)
            # PIPE2THIRTEEN_CONSUMER_CHANNEl  <pipeconnection4xi.PipeConnection4Xi object at 0x02C3A530>
            print ("(STEP 113A3/33) OF TEST_GUN4SEARCH - PASSING PIPE2THIRTEEN_PUBLISHER_CHANNEL ", pipe2thirteen_publisher_channel )
            # PIPE2THIRTEEN_PUBLISHER_CHANNEL  <pipeconnection4xi.PipeConnection4Xi object at 0x02C3A510>
            print ("(STEP 113A4/33) OF TEST_GUN4SEARCH - PASSING THIRTEEN2ANALYSE4SEARCH ", thirteen2analyse4search)
            # THIRTEEN2ANALYSE4SEARCH  M://temp//yophotos//test2thirteen//
            print ("(STEP 113A5/33) OF TEST_GUN4SEARCH - USING TARPEGT FUNCTION GUN2THIRTEEN4SEARCH ", gun2thirteen4search)
            # <module 'gun2thirteen4search' from 'E://temp//dragonize//out//gun2thirteen4search.py'>
        except:
            print ("(STEP 113Z1/33) OF TEST_GUN4SEARCH *** FAILED WITH PARAMETERS ", time4xi())
                 
        try:         
            # -----------------------------------------------------------------------------------------    
            # THIRTEEN-PROCESS WITH TARGET FUNCTION CREATION
            # -----------------------------------------------------------------------------------------                     
            p2thirteen = Process4Xi(target=gun2thirteen4search, args=(queue2thirteen, pipe2thirteen_consumer_channel, pipe2thirteen_publisher_channel, thirteen2analyse4search))
            print("(STEP 113A7/33) OF TEST_GUN4SEARCH - CREATED PROCESS OBJECT P2THIRTEEN: ", p2thirteen)                     
            # 
        except:
            print ("(STEP 113Z2/33) OF TEST_GUN4SEARCH *** FAILED TO CREATE PROCESS WITH TARGET FUNCTION ", time4xi())
    
                            
        try:        
            # -----------------------------------------------------------------------------------------    
            # THIRTEEN-PROCESS NAME
            # -----------------------------------------------------------------------------------------                        
            name2thirteen = p2thirteen.name
            print("(STEP 113A8/33) OF TEST_GUN4SEARCH - CREATED PROCESS NAME: ", name2thirteen) 
            # { Process4Xi : name ; returning; name-property-of-process2xi-returning-by-name-of-Process4Xi: Process4Xi-15; time: 12:32:47 02/06/15 FLE Standard Time}
            # CREATED PROCESS NAME:  Process4Xi-15
        except:
            print ("(STEP 113Z3/33) OF TEST_GUN4SEARCH *** FAILED TO GET NAME OF PROCESS ", time4xi())
                
        try:         
            # -----------------------------------------------------------------------------------------    
            # THIRTEEN-PROCESS START
            # ----------------------------------------------------------------------------------------- 
            p2thirteen.start()
            print("(STEP 113A9/33) OF TEST_GUN4SEARCH - STARTED PROCESS NAME: ", name2thirteen)
            # { Process4Xi : __init__ ; (Step 0/15d) passed; target-passed-to-init-of-Process4Xi: <module 'gun2thirteen4search' from 'E:\\STUDIO4XI\\Python\\3.3\\src\\gun2thirteen4search.py'>
            # { Process4Xi : start ; (Step 2/7a) got; pid2xi-got-by-start-of-Process4Xi: 7272
            # { Process4Xi : __repr__ ; (Step 2/3c) set; status-set-by-repr-of-Process4Xi to: stopped[1]
            # STARTED PROCESS NAME:  Process4Xi-15
        except:
            print ("(STEP 113Z4/33) OF TEST_GUN4SEARCH *** FAILED TO START PROCESS ", time4xi())
            
        try:        
            # -----------------------------------------------------------------------------------------    
            # THIRTEEN-PROCESS ALIVE CHECK
            # -----------------------------------------------------------------------------------------                   
            status4p2thirteen = p2thirteen.is_alive()
            print("(STEP 113A10/33) OF TEST_GUN4SEARCH - PROCESS STATUS: ", status4p2thirteen)
            # PROCESS STATUS:  True
        except:
            print ("(STEP 113Z5/33) OF TEST_GUN4SEARCH *** FAILED TO CHECK IF PROCESS IS ALIVE ", time4xi())
            
                    
        try:            
            # -----------------------------------------------------------------------------------------    
            # THIRTEEN-PROCESS RUN
            # -----------------------------------------------------------------------------------------
            p2thirteen.run()
            print("(STEP 113A11/33) OF TEST_GUN4SEARCH - PERFORMED RUN COMMAND TO PROCESS NAME: ", name2thirteen)
            # { Process4Xi : run ; Step (1/2a) calling; target-of-process2xi-calling-by-run-of-Process4Xi: <module 'gun2thirteen4search' from 'E://temp//dragonize//out//gun2thirteen4search.py'> 
            # { Process4Xi : run ; Step (1/2a) calling; target-of-process2xi-calling-by-run-of-Process4Xi: <module 'gun2thirteen4search' from 'E:\\STUDIO4XI\\Python\\3.3\\src\\gun2thirteen4search.py'>
            ack4run = True 
        except:
            print ("(STEP 113Z6/33) OF TEST_GUN4SEARCH *** FAILED TO RUN PROCESS ", time4xi())
            # *** FAILED TO RUN PROCESS  12:08:09 02/06/15 FLE Standard Time <-- generate to temp folder
            # *** FAILED TO RUN PROCESS <-- generated and moved to normal folder!
        try:
            # --------------------------------------------------------------------------------
            # THIRTEEN-PROCESS - GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES                         
            # --------------------------------------------------------------------------------   
            print ("(STEP 113A12/33) OF TEST_GUN4SEARCH - GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES  ", time4xi())  
            # 
            message2get4thirteen = queue2thirteen.get()
            print("(STEP 113A14/33) OF TEST_GUN4SEARCH - GOT FROM QUEUE2THIRTEEN: ", queue2thirteen, " MESSAGE: ", message2get4thirteen)
            # GOT FROM QUEUE2THIRTEEN:  <queue4xi.Queue4Xi object at 0x02C3A770>  MESSAGE:  <copy4xi>copy2thirteen</copy4xi> 
        except:
            print ("(STEP 113Z7/33) OF TEST_GUN4SEARCH *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES ", time4xi())    
                        
        try:
            # --------------------------------------------------------------------------------
            # THIRTEEN-PROCESS - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM PIPES                          
            # --------------------------------------------------------------------------------       
            print("(STEP 113A15/33) OF TEST_GUN4SEARCH - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM PIPES ", time4xi())  
            # 
            message2receive4thirteen = pipe2thirteen_consumer_channel.recv()
            print("(STEP 113A16/33) OF TEST_GUN4SEARCH - RECEIVED FROM PIPE2THIRTEEN_CONSUMER_CHANNEL: ", pipe2thirteen_consumer_channel, " MESSAGE: ", message2receive4thirteen)
            # RECEIVED FROM PIPE2THIRTEEN_CONSUMER_CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x02C3A530>  MESSAGE:  <copy4xi>copy2thirteen</copy4xi>
        except:
            print ("(STEP 113Z8/33) OF TEST_GUN4SEARCH *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM PIPES ", time4xi())            

    
    # JATKA  - MIKSI JOSKUS ON MODULI JA JOSKUS FUNKTIO ???                  
    print("(STEP 130C15/33) OF TEST_GUN4SEARCH - TRYING TO CALL DIRECTLY GUN2TWELVE4SEARCH ", gun2twelve4search)      
    # <function gun2twelve4search at 0x02A495D0> <--> why is it now module 'gun2twelve4search' from 'E:\\STUDIO4XI\\Python\\3.3\\src\\gun2twelve4search.py'>
    try:        
        
        gun2twelve4search(twelve2analyse4search)
        print("(STEP 130E15/33) OF TEST_GUN4SEARCH - PERFORMED GUN2TWELVE4SEARCH ", gun2twelve4search)  
        # PERFORMED GUN2TWELVE4SEARCH  <function gun2twelve4search at 0x02BCD5D0> <-- returns although skips jobs          
    except:
        print("(STEP 130Z1/33) OF TEST_GUN4SEARCH *** FAILED TO PERFORM GUN2TWELVE4SEARCH ", gun2twelve4search)  
        #  
                                
    print("(STEP 140C15/33) OF TEST_GUN4SEARCH - TRYING TO CALL DIRECTLY GUN2THIRTEEN4SEARCH ", gun2thirteen4search)   
    # GUN2THIRTEEN4SEARCH  <module 'gun2thirteen4search' from 'E:\\STUDIO4XI\\Python\\3.3\\src\\gun2thirteen4search.py'> <-- why module ???
    try:        
        
        gun2thirteen4search(thirteen2analyse4search)
        print("(STEP 140E15/33) OF TEST_GUN4SEARCH - PERFORMED GUN2THIRTEEN4SEARCH ", gun2thirteen4search)  
        #          
    except:
        print("(STEP 140Z1/33) OF TEST_GUN4SEARCH *** FAILED TO PERFORM GUN2THIRTEEN4SEARCH ", gun2thirteen4search)  
        # fails immediatelly        
                                       
    #dynamic-end    
                

            
    # =============================================================================================   
    # (Step 33/33)
    # =============================================================================================    
         
    print('=' *75)
    print("(Step 33A/33) OF TEST_GUN4SEARCH FOR ", master2analyse4search, " COMPLETED  ", time4xi())
    #  J://temp//yophotos//test2master//  COMPLETED   11:02:01 01/23/15 FLE Standard Time
    
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print ('(STEP 33B/33) OF TEST_GUN4SEARCH - PRINTING TRACE WITH T2XI', t2xi) 
    # <print4xi.Print4Xi object at 0x029C5570>
    
    print_trace4xi(t2xi)        
    print ('(STEP 33C/33) OF TEST_GUN4SEARCH - PRINTED TRACE WITH T2XI', t2xi)           
    # <print4xi.Print4Xi object at 0x029C5570>
    # { Queue4Xi : _finalize_close ; (Step 0/6a) started; finalize-close-of-Queue4Xi-started: ; time: 11:03:09 01/20/15 FLE Standard Time}
    # ...
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\test_gun4search.txt
# \web\xml\ace-test_gun4search.xml
# \web\xml\reason-test_gun4search.xml
# \web\xml\sense-test_gun4search.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_gun4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

